Index: c/src/lib/libbsp/arm/shared/include/linker-symbols.h
===================================================================
--- c/src/lib/libbsp/arm/shared/include/linker-symbols.h	(revision 8fdf4e57f87ce16cac7739adb26ee11e1098ceb1)
+++ c/src/lib/libbsp/arm/shared/include/linker-symbols.h	(revision 4ec210fe3e079cc3ab0f8d82e209a6864c592075)
@@ -84,10 +84,4 @@
 LINKER_SYMBOL(bsp_section_rodata_load_end)
 
-LINKER_SYMBOL(bsp_section_armexidx_begin)
-LINKER_SYMBOL(bsp_section_armexidx_end)
-LINKER_SYMBOL(bsp_section_armexidx_size)
-LINKER_SYMBOL(bsp_section_armexidx_load_begin)
-LINKER_SYMBOL(bsp_section_armexidx_load_end)
-
 LINKER_SYMBOL(bsp_section_data_begin)
 LINKER_SYMBOL(bsp_section_data_end)
Index: c/src/lib/libbsp/arm/shared/include/start.h
===================================================================
--- c/src/lib/libbsp/arm/shared/include/start.h	(revision 8fdf4e57f87ce16cac7739adb26ee11e1098ceb1)
+++ c/src/lib/libbsp/arm/shared/include/start.h	(revision 4ec210fe3e079cc3ab0f8d82e209a6864c592075)
@@ -100,11 +100,4 @@
   );
 
-  /* Copy .ARM.exidx section */
-  bsp_start_memcpy(
-    (int *) bsp_section_armexidx_begin,
-    (const int *) bsp_section_armexidx_load_begin,
-    (size_t) bsp_section_armexidx_size
-  );
-
   /* Copy .data section */
   bsp_start_memcpy(
Index: c/src/lib/libbsp/arm/shared/startup/linkcmds.base
===================================================================
--- c/src/lib/libbsp/arm/shared/startup/linkcmds.base	(revision 8fdf4e57f87ce16cac7739adb26ee11e1098ceb1)
+++ c/src/lib/libbsp/arm/shared/startup/linkcmds.base	(revision 4ec210fe3e079cc3ab0f8d82e209a6864c592075)
@@ -66,5 +66,5 @@
 
 SECTIONS {
-	.start : {
+	.start : ALIGN_WITH_INPUT {
 		bsp_section_start_begin = .;
 		KEEP (*(.bsp_start_text))
@@ -74,12 +74,10 @@
 	bsp_section_start_size = bsp_section_start_end - bsp_section_start_begin;
 
-	.xbarrier : {
+	.xbarrier : ALIGN_WITH_INPUT {
 		. = ALIGN (bsp_section_xbarrier_align);
 	} > REGION_VECTOR
 
-	.text : ALIGN(32) {
+	.text : ALIGN_WITH_INPUT {
 		bsp_section_text_begin = .;
-
-		/* .text */
 		*(.text.unlikely .text.*_unlikely)
 		*(.text .stub .text.* .gnu.linkonce.t.*)
@@ -87,11 +85,10 @@
 		*(.gnu.warning)
 		*(.glue_7t) *(.glue_7) *(.vfp11_veneer) *(.v4_bx)
-
-		/* .init */
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.init : ALIGN_WITH_INPUT {
 		KEEP (*(.init))
-
-		/* .fini */
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.fini : ALIGN_WITH_INPUT {
 		KEEP (*(.fini))
-
 		bsp_section_text_end = .;
 	} > REGION_TEXT AT > REGION_TEXT_LOAD
@@ -100,50 +97,53 @@
 	bsp_section_text_load_end = bsp_section_text_load_begin + bsp_section_text_size;
 
-	.robarrier : {
+	.robarrier : ALIGN_WITH_INPUT {
 		. = ALIGN (bsp_section_robarrier_align);
 	} > REGION_RODATA
 
-	.rodata : ALIGN(32) {
+	.rodata : ALIGN_WITH_INPUT {
 		bsp_section_rodata_begin = .;
-
-		/* .rodata */
 		*(.rodata .rodata.* .gnu.linkonce.r.*)
-
-		/* .rodata1 */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.rodata1 : ALIGN_WITH_INPUT {
 		*(.rodata1)
-
-		/* .ARM.extab */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.ARM.extab : ALIGN_WITH_INPUT {
 		*(.ARM.extab* .gnu.linkonce.armextab.*)
-
-		/* .eh_frame */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.ARM.exidx : ALIGN_WITH_INPUT {
+		__exidx_start = .;
+		*(.ARM.exidx* .gnu.linkonce.armexidx.*)
+		__exidx_end = .;
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.eh_frame : ALIGN_WITH_INPUT {
 		KEEP (*(.eh_frame))
-
-		/* .gcc_except_table */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.gcc_except_table : ALIGN_WITH_INPUT {
 		*(.gcc_except_table .gcc_except_table.*)
-
-		/* .tdata */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.tdata : ALIGN_WITH_INPUT {
 		*(.tdata .tdata.* .gnu.linkonce.td.*)
-
-		/* .tbss */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.tbss : ALIGN_WITH_INPUT {
 		*(.tbss .tbss.* .gnu.linkonce.tb.*) *(.tcommon)
-
-		/* .preinit_array */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.preinit_array : ALIGN_WITH_INPUT {
 		PROVIDE_HIDDEN (__preinit_array_start = .);
 		KEEP (*(.preinit_array))
 		PROVIDE_HIDDEN (__preinit_array_end = .);
-
-		/* .init_array */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.init_array : ALIGN_WITH_INPUT {
 		PROVIDE_HIDDEN (__init_array_start = .);
 		KEEP (*(SORT(.init_array.*)))
 		KEEP (*(.init_array))
 		PROVIDE_HIDDEN (__init_array_end = .);
-
-		/* .fini_array */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.fini_array : ALIGN_WITH_INPUT {
 		PROVIDE_HIDDEN (__fini_array_start = .);
 		KEEP (*(.fini_array))
 		KEEP (*(SORT(.fini_array.*)))
 		PROVIDE_HIDDEN (__fini_array_end = .);
-
-		/* .ctors */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.ctors : ALIGN_WITH_INPUT {
 		/* gcc uses crtbegin.o to find the start of
 		   the constructors, so we make sure it is
@@ -164,6 +164,6 @@
 		KEEP (*(SORT(.ctors.*)))
 		KEEP (*(.ctors))
-
-		/* .dtors */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.dtors : ALIGN_WITH_INPUT {
 		KEEP (*crtbegin.o(.dtors))
 		KEEP (*crtbegin?.o(.dtors))
@@ -171,40 +171,40 @@
 		KEEP (*(SORT(.dtors.*)))
 		KEEP (*(.dtors))
-
-		/* .data.rel.ro */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.data.rel.ro : ALIGN_WITH_INPUT {
 		*(.data.rel.ro.local* .gnu.linkonce.d.rel.ro.local.*)
 		*(.data.rel.ro* .gnu.linkonce.d.rel.ro.*)
-
-		/* .jcr */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.jcr : ALIGN_WITH_INPUT {
 		KEEP (*(.jcr))
-
-		/* .interp */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.interp : ALIGN_WITH_INPUT {
 		*(.interp)
-
-		/* .note.gnu.build-id */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.note.gnu.build-id : ALIGN_WITH_INPUT {
 		*(.note.gnu.build-id)
-
-		/* .hash */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.hash : ALIGN_WITH_INPUT {
 		*(.hash)
-
-		/* .gnu.hash */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.gnu.hash : ALIGN_WITH_INPUT {
 		*(.gnu.hash)
-
-		/* .dynsym */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.dynsym : ALIGN_WITH_INPUT {
 		*(.dynsym)
-
-		/* .dynstr */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.dynstr : ALIGN_WITH_INPUT {
 		*(.dynstr)
-
-		/* .gnu.version */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.gnu.version : ALIGN_WITH_INPUT {
 		*(.gnu.version)
-
-		/* .gnu.version_d */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.gnu.version_d : ALIGN_WITH_INPUT {
 		*(.gnu.version_d)
-
-		/* .gnu.version_r */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.gnu.version_r : ALIGN_WITH_INPUT {
 		*(.gnu.version_r)
-
-		/* .rel.dyn */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.rel.dyn : ALIGN_WITH_INPUT {
 		*(.rel.init)
 		*(.rel.text .rel.text.* .rel.gnu.linkonce.t.*)
@@ -224,6 +224,6 @@
 		PROVIDE_HIDDEN (__rela_iplt_start = .);
 		PROVIDE_HIDDEN (__rela_iplt_end = .);
-
-		/* .rela.dyn */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.rela.dyn : ALIGN_WITH_INPUT {
 		*(.rela.init)
 		*(.rela.text .rela.text.* .rela.gnu.linkonce.t.*)
@@ -242,23 +242,24 @@
 		*(.rela.iplt)
 		PROVIDE_HIDDEN (__rela_iplt_end = .);
-
-		/* .rel.plt */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.rel.plt : ALIGN_WITH_INPUT {
 		*(.rel.plt)
-
-		/* .rela.plt */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.rela.plt : ALIGN_WITH_INPUT {
 		*(.rela.plt)
-
-		/* .plt */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.plt : ALIGN_WITH_INPUT {
 		*(.plt)
-
-		/* .iplt */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.iplt : ALIGN_WITH_INPUT {
 		*(.iplt)
-
-		/* .dynamic */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.dynamic : ALIGN_WITH_INPUT {
 		*(.dynamic)
-
-		/* .got */
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.got : ALIGN_WITH_INPUT {
 		*(.got.plt) *(.igot.plt) *(.got) *(.igot)
-
+	} > REGION_RODATA AT > REGION_RODATA_LOAD
+	.rtemsroset : ALIGN_WITH_INPUT {
 		/* Special FreeBSD linker set sections */
 		__start_set_sysctl_set = .;
@@ -267,11 +268,6 @@
 		*(set_domain_*);
 		*(set_pseudo_*);
-		_bsd__start_set_modmetadata_set = .;
-		*(_bsd_set_modmetadata_set);
-		_bsd__stop_set_modmetadata_set = .;
-		_bsd__start_set_sysctl_set = .;
-		*(_bsd_set_sysctl_set);
-		_bsd__stop_set_sysctl_set = .;
-
+
+		KEEP (*(SORT(.rtemsroset.*)))
 		bsp_section_rodata_end = .;
 	} > REGION_RODATA AT > REGION_RODATA_LOAD
@@ -280,23 +276,9 @@
 	bsp_section_rodata_load_end = bsp_section_rodata_load_begin + bsp_section_rodata_size;
 
-	.ARM.exidx : ALIGN(32) {
-		bsp_section_armexidx_begin = .;
-
-		/* .ARM.exidx */
-		__exidx_start = .;
-		*(.ARM.exidx* .gnu.linkonce.armexidx.*)
-		__exidx_end = .;
-
-		bsp_section_armexidx_end = .;
-	} > REGION_RODATA AT > REGION_RODATA_LOAD
-	bsp_section_armexidx_size = bsp_section_armexidx_end - bsp_section_armexidx_begin;
-	bsp_section_armexidx_load_begin = LOADADDR (.ARM.exidx);
-	bsp_section_armexidx_load_end = bsp_section_armexidx_load_begin + bsp_section_armexidx_size;
-
-	.rwbarrier : {
+	.rwbarrier : ALIGN_WITH_INPUT {
 		. = ALIGN (bsp_section_rwbarrier_align);
 	} > REGION_DATA
 
-	.vector : {
+	.vector : ALIGN_WITH_INPUT {
 		bsp_section_vector_begin = .;
 
@@ -334,5 +316,4 @@
 
 		*(.bsp_vector)
-
 		bsp_section_vector_end = .;
 	} > REGION_VECTOR AT > REGION_VECTOR
@@ -341,5 +322,5 @@
 	bsp_vector_table_end = bsp_vector_table_begin + bsp_vector_table_size;
 
-	.fast_text : {
+	.fast_text : ALIGN_WITH_INPUT {
 		bsp_section_fast_text_begin = .;
 		*(.bsp_fast_text)
@@ -350,5 +331,5 @@
 	bsp_section_fast_text_load_end = bsp_section_fast_text_load_begin + bsp_section_fast_text_size;
 
-	.fast_data : ALIGN(32) {
+	.fast_data : ALIGN_WITH_INPUT {
 		bsp_section_fast_data_begin = .;
 		*(.bsp_fast_data)
@@ -359,19 +340,14 @@
 	bsp_section_fast_data_load_end = bsp_section_fast_data_load_begin + bsp_section_fast_data_size;
 
-	.data : ALIGN(32) {
+	.data : ALIGN_WITH_INPUT {
 		bsp_section_data_begin = .;
-
-		/* .data */
 		*(.data .data.* .gnu.linkonce.d.*)
 		SORT(CONSTRUCTORS)
-
-		/* .data1 */
+	} > REGION_DATA AT > REGION_DATA_LOAD
+	.data1 : ALIGN_WITH_INPUT {
 		*(.data1)
-
-		/* Special FreeBSD linker set sections */
-		_bsd__start_set_sysinit_set = .;
-		*(_bsd_set_sysinit_set);
-		_bsd__stop_set_sysinit_set = .;
-
+	} > REGION_DATA AT > REGION_DATA_LOAD
+	.rtemsrwset : ALIGN_WITH_INPUT {
+		KEEP (*(SORT(.rtemsrwset.*)))
 		bsp_section_data_end = .;
 	} > REGION_DATA AT > REGION_DATA_LOAD
@@ -380,17 +356,14 @@
 	bsp_section_data_load_end = bsp_section_data_load_begin + bsp_section_data_size;
 
-	.bss : {
+	.bss : ALIGN_WITH_INPUT {
 		bsp_section_bss_begin = .;
-
-		/* .bss */
 		*(.dynbss)
 		*(.bss .bss.* .gnu.linkonce.b.*)
 		*(COMMON)
-
 		bsp_section_bss_end = .;
 	} > REGION_BSS AT > REGION_BSS
 	bsp_section_bss_size = bsp_section_bss_end - bsp_section_bss_begin;
 
-	.work : {
+	.work : ALIGN_WITH_INPUT {
 		/*
 		 * The work section will occupy the remaining REGION_WORK region and
@@ -403,5 +376,5 @@
 	bsp_section_work_size = bsp_section_work_end - bsp_section_work_begin;
 
-	.stack : {
+	.stack : ALIGN_WITH_INPUT {
 		/*
 		 * The stack section will occupy the remaining REGION_STACK region and may
